/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2009                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


#ifndef PEARL_REPLAY_H
#define PEARL_REPLAY_H


/*-------------------------------------------------------------------------*/
/**
 * @file    pearl_replay.h
 * @ingroup PEARL_replay
 * @brief   Declarations of replay-related library functions.
 *
 * This header file provides declarations of all replay-related library
 * functions provided by PEARL.
 */
/*-------------------------------------------------------------------------*/


namespace pearl
{

//--- Forward declarations --------------------------------------------------

class CallbackData;
class CallbackManager;
class LocalTrace;


//--- Function prototypes ---------------------------------------------------

/// @name Replay functionality
/// @{

extern void PEARL_forward_replay (const LocalTrace&      trace,
                                  const CallbackManager& cbmanager,
                                  CallbackData*          data);
extern void PEARL_backward_replay(const LocalTrace&      trace,
                                  const CallbackManager& cbmanager,
                                  CallbackData*          data);

/// @}


}   /* namespace pearl */


#endif   /* !PEARL_REPLAY_H */
